package com.example.demo.controller;

import com.example.demo.service.S3service;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
@RequestMapping(value = "/api")
public class Awscontroller {

    private final S3service service;

    @Autowired
    public Awscontroller(S3service s3service) {
        this.service = s3service;
    }

    // curl 'http://localhost:9030/api/list?bucket=your_destination_bucket'

    @GetMapping(value = "/list")
    @ResponseStatus(HttpStatus.OK)
    public List<String> getAllFiles(@RequestParam(name = "bucket", required = false) String bucket) {
        return service.listFiles(bucket);
    }

    // curl 'http://localhost:9030/api/moveAndDelete?source-key=your_source_key&destination-bucket=your_destination_bucket'

    @GetMapping(value = "/moveAndDelete")
    @ResponseStatus(HttpStatus.OK)
    public String moveAndDelete(@RequestParam("source-key") String sKey, @RequestParam("destination-bucket") String dBucket) {
        // skipping key name validation

        // skipping destination bucket validation

        // destination bucket should be in same region as source bucket

        return service.moveAndDeleteKeyFromSource(sKey, dBucket);
    }

    // curl 'http://localhost:9030/api/move-all?destination-bucket=your_destination_bucket'

    @GetMapping(value = "/move-all")
    @ResponseStatus(HttpStatus.OK)
    public List<String> moveAll(@RequestParam("destination-bucket") String dBucket) {
        // skipping destination bucket validation

        // destination bucket should be in same region as source bucket

        return service.moveAllKeysToDestination(dBucket);
    }


    // curl 'http://localhost:9030/api/moveAndDelete?source-key=your_source_key&destination-key=your_destination_key&destination-bucket=your_destination_bucket'

    @GetMapping(value = "/rename")
    @ResponseStatus(HttpStatus.OK)
    public String rename(@RequestParam("source-key") String sKey,
                         @RequestParam("destination-key") String dKey,
                         @RequestParam("destination-bucket") String dBucket) {
        // skipping key names validation

        // skipping destination bucket validation

        // destination bucket should be in same region as source bucket

        return service.moveKeyToDestination(sKey, dKey, dBucket);
    }
}
